<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class OrderRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('orders'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=
            [
                'status'=>[
                    'required',
                    'in:new,onboard,finished,canceled'
                ],
                'user_id'=> [
                    'required',
                    Rule::exists('users', 'id')->where('role','user')->whereNull('deleted_at')
                ],
                'area_id'=> [
                    'required',
                    Rule::exists('categories', 'id')->whereNull('deleted_at')
                ],
                'city_id'=> [
                    'required',
                    Rule::exists('cities', 'id')->whereNull('deleted_at')
                ],
                'time_zone_id'=> [
                    'required',
                    Rule::exists('time_zones', 'id')->whereNull('deleted_at')
                ],
                'delivery_id'=> [
                    'required',
                    Rule::exists('users', 'id')->where('role','delivery')->whereNull('deleted_at')
                ],
//                'latitude' =>[
//                    'required'
//                ],
//                'longitude'=>[
//                    'required'
//                ],
                'image'=>[
                    'required'
                ],
                'note'=>[
                    'sometimes'
                ],
            ];

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=
            [
                'area_id'=>__('orders.area_id'),
                'city_id'=>__('orders.city_id'),
                'user_id'=>__('orders.user_id'),
                'delivery_id'=>__('orders.delivery_id'),
                'time_zone_id'=>__('orders.time_zone_id'),
                'status'=>__('orders.status'),
                'latitude'=>__('orders.latitude'),
                'longitude'=>__('orders.longitude'),
                'image'=>__('orders.image'),
                'note'=>__('orders.note'),
            ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
